# DevOps Apprenticeship: Project Exercise

> If you are using GitPod for the project exercise (i.e. you cannot use your local machine) then you'll want to launch a VM using the [following link](https://gitpod.io/#https://github.com/CorndelWithSoftwire/DevOps-Course-Starter). Note this VM comes pre-setup with Python & Poetry pre-installed.

## System Requirements

The project uses poetry for Python to create an isolated environment and manage package dependencies. To prepare your system, ensure you have an official distribution of Python version 3.7+ and install Poetry using one of the following commands (as instructed by the [poetry documentation](https://python-poetry.org/docs/#system-requirements)):

### Poetry installation (Bash)

```bash
curl -sSL https://raw.githubusercontent.com/python-poetry/poetry/master/install-poetry.py | python -
```

### Poetry installation (PowerShell)

```powershell
(Invoke-WebRequest -Uri https://raw.githubusercontent.com/python-poetry/poetry/master/install-poetry.py -UseBasicParsing).Content | python -
```

## Dependencies

The project uses a virtual environment to isolate package dependencies. To create the virtual environment and install required packages, run the following from your preferred shell:

```bash
$ poetry install
```

You'll also need to clone a new `.env` file from the `.env.template` to store local configuration options. This is a one-time operation on first setup:

```bash
$ cp .env.template .env  # (first time only)
```

The `.env` file is used by flask to set environment variables when running `flask run`. This enables things like development mode (which also enables features like hot reloading when you make a file change). There's also a [SECRET_KEY](https://flask.palletsprojects.com/en/1.1.x/config/#SECRET_KEY) variable which is used to encrypt the flask session cookie.

## Running the App

Once the all dependencies have been installed, start the Flask app in development mode within the Poetry environment by running:
```bash
$ poetry run flask run
```

You should see output similar to the following:
```bash
 * Serving Flask app "app" (lazy loading)
 * Environment: development
 * Debug mode: on
 * Running on http://127.0.0.1:5000/ (Press CTRL+C to quit)
 * Restarting with fsevents reloader
 * Debugger is active!
 * Debugger PIN: 226-556-590
```
Now visit [`http://localhost:5000/`](http://localhost:5000/) in your web browser to view the app.

## Casual Help to Refer to make changes
```
##
Python Interpreter command =  Ctrl+Shift+P
# {% ... %} for Statements
# {{ ... }} for Expressions to print to the template output
# {# ... #} for Comments not included in the template output
# # ... ## for Line Statements

```

## Usefull Tips to run the project
```
##.env files configuration
* We need 3 variables to be setup in .env files to run the app. They are TRELLO_ACCOUNT_TOKEN, TRELLO_DEV_KEY and TRELLO_BOARD_ID.
* Once we create Trello Account, Account token and Dev key can be generated. Create an account at https://trello.com/ 
* If no board is created on your profile, create a new board and get the board Id using Trello API.
* e.g If you created board has name "devopsTest", then corresponding json is https://trello.com/b/oIIuX5mf/devopsTest.json
* id is returned as first key value pair in json and can be used for further updates on your board.
* Rest API's of Trello is located at https://developer.atlassian.com/cloud/trello/rest/api-group-actions/

## run flask
* Add requests to pyproject.toml by running "poetry add requests" on terminal.
* cd "C:\Users\rsand\OneDrive\Desktop\DevopsAssignments\Assignments\Module1\DevOps-Course-Starter"
* poetry run flask run

```